#include "stdafx.h"

#include "blowfish/blowfish.h"
#include "blowfish/blowfish.h2"

using namespace std;

unsigned char NODE_ENC_KEY[] = "222nullpo";

char ascii2bin(char c)
{
	if (c >= '0' && c <= '9') return (c & 0x0f);
	else return ((c & 0x0f) + 9);
}

template <typename T, std::size_t N>
inline std::size_t arraysize(T (&)[N]) { return N; }

string encrypt(const string& src)
{
	CBlowFish bf;
	bf.Initialize(NODE_ENC_KEY, arraysize(NODE_ENC_KEY) -1);
	vector<unsigned char> buf(bf.GetOutputLength(src.length()));
	buf.resize(bf.Encode(reinterpret_cast<unsigned char*>(const_cast<char*>(src.data())),
		&buf[0], src.length()));

	string str;
	for (vector<unsigned char>::iterator it = buf.begin(); it != buf.end(); ++it) {
		char tmp[8];
		sprintf(tmp, "%02x", *it);
		str += tmp;
	}
	return str;
}

string decrypt(const string& src)
{
	if (src.length() % 2)
		return string();

	vector<unsigned char> srcbuf;
	for (string::const_iterator it = src.begin(); it != src.end(); ++it) {
		srcbuf.push_back((ascii2bin(*it) << 4) | ascii2bin(*(++it)));
	}
	CBlowFish bf;
	bf.Initialize(NODE_ENC_KEY, arraysize(NODE_ENC_KEY) -1);
	vector<char> buf(bf.GetOutputLength(srcbuf.size()));
	bf.Decode(&srcbuf[0], reinterpret_cast<unsigned char*>(&buf[0]), srcbuf.size());

	string cleartext(buf.begin(), buf.end());
	size_t pos = cleartext.find('\0');
	if (strfound(pos)) {
		cleartext.erase(pos);
	}
	return cleartext;
}
