// MakeRIPEMD160.cpp: CMakeRIPEMD160 NX̃Cve[V
//
////////////////////////////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "MakeRIPEMD160.h"


static void MakeRIPEMD160Helper_c(const void *pBuffer, void *hash, DWORD len);
extern "C" void CDECL MakeRIPEMD160Helper_asm(const void *pBuffer, void *hash, DWORD len);


static const DWORD hinit[] = { 0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0 };
static const DWORD k1[] = { 0x00000000, 0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xa953fd4e };
static const DWORD k2[] = { 0x50a28be6, 0x5c4dd124, 0x6d703ef3, 0x7a6d76e9, 0x00000000 };
static const DWORD r1[] = {
   0,  1,  2,  3,  4,  5,  6,  7,  8,  9, 10, 11, 12, 13, 14, 15,
   7,  4, 13,  1, 10,  6, 15,  3, 12,  0,  9,  5,  2, 14, 11,  8,
   3, 10, 14,  4,  9, 15,  8,  1,  2,  7,  0,  6, 13, 11,  5, 12,
   1,  9, 11, 10,  0,  8, 12,  4, 13,  3,  7, 15, 14,  5,  6,  2,
   4,  0,  5,  9,  7, 12,  2, 10, 14,  1,  3,  8, 11,  6, 15, 13
};
static const DWORD s1[] = {
  11, 14, 15, 12,  5,  8,  7,  9, 11, 13, 14, 15,  6,  7,  9,  8,
   7,  6,  8, 13, 11,  9,  7, 15,  7, 12, 15,  9, 11,  7, 13, 12,
  11, 13,  6,  7, 14,  9, 13, 15, 14,  8, 13,  6,  5, 12,  7,  5,
  11, 12, 14, 15, 14, 15,  9,  8,  9, 14,  5,  6,  8,  6,  5, 12,
   9, 15,  5, 11,  6,  8, 13, 12,  5, 12, 13, 14, 11,  8,  5,  6
};
static const DWORD r2[] = {
   5, 14,  7,  0,  9,  2, 11,  4, 13,  6, 15,  8,  1, 10,  3, 12,
   6, 11,  3,  7,  0, 13,  5, 10, 14, 15,  8, 12,  4,  9,  1,  2,
  15,  5,  1,  3,  7, 14,  6,  9, 11,  8, 12,  2, 10,  0,  4, 13,
   8,  6,  4,  1,  3, 11, 15,  0,  5, 12,  2, 13,  9,  7, 10, 14,
  12, 15, 10,  4,  1,  5,  8,  7,  6,  2, 13, 14,  0,  3,  9, 11
};
static const DWORD s2[] = {
   8,  9,  9, 11, 13, 15, 15,  5,  7,  7,  8, 11, 14, 14, 12,  6,
   9, 13, 15,  7, 12,  8,  9, 11,  7,  7, 12,  7,  6, 15, 13, 11,
   9,  7, 15, 11,  8,  6,  6, 14, 12, 13,  5, 14, 13, 13,  7,  5,
  15,  5,  8, 11, 14, 14,  6, 14,  6,  9, 12,  9, 12,  5, 15,  8,
   8,  5, 12,  9, 12,  5, 14,  6,  8, 13,  6,  5, 15, 13, 11, 11
};


////////////////////////////////////////////////////////////////////////////////////////////////////

CMakeRIPEMD160::CMakeRIPEMD160()
{
    Initialize();
}

CMakeRIPEMD160::~CMakeRIPEMD160()
{
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void CMakeRIPEMD160::Initialize()
{
    CMakeHashAlgorithm::Initialize();
    memcpy(m_pHash, hinit, 20);
}

////////////////////////////////////////////////////////////////////////////////////////////////////

void CMakeRIPEMD160::ComputeHashFinalHelper(void *msg_digest)
{
    BYTE buf[64];
    DWORD len;
    QWORD string_bit_len;

    memcpy(msg_digest, m_pHash, 20);

    len = m_dwRestLen;
    memcpy(buf, m_pRest, len);
    memset(buf+len, 0, 64-len);
    buf[len] |= 0x80;

    if ( len >= 56 )
    {
        ComputeHashHelper(buf, msg_digest, 64);
        memset(buf, 0, 56);
    }

    string_bit_len = m_qwSrcLen * 8;
    memcpy(&buf[56], &string_bit_len, 8);

    ComputeHashHelper(buf, msg_digest, 64);
}

DWORD CMakeRIPEMD160::ComputeHashHelper(const void *pBuffer, void *msg_digest, DWORD len)
{
#if (USE_ASSEMBLER_RIPEMD160==0)
    MakeRIPEMD160Helper_c(pBuffer, msg_digest, len);
#else
    MakeRIPEMD160Helper_asm(pBuffer, msg_digest, len);
#endif
    return len % 64;
}


////////////////////////////////////////////////////////////////////////////////////////////////////
// C

#define F1(x, y, z)      ( (x) ^ (y) ^ (z) )
#define F2(x, y, z)      ( ((x)&(y)) | ((~(x))&(z)) )
#define F3(x, y, z)      ( ((x)|(~(y))) ^ z )
#define F4(x, y, z)      ( ((x)&(z)) | ((y)&(~(z))) )
#define F5(x, y, z)      ( (x) ^ ((y)|(~(z))) )

#define subSUBROUND1(a, bcd, e, k, i)      ( ROTATE_L32(a+bcd+w[r1[i]]+k,s1[i]) + e )
#define subSUBROUND2(a, bcd, e, k, i)      ( ROTATE_L32(a+bcd+w[r2[i]]+k,s2[i]) + e )

#define SUBROUND1(funcname, a, b, c, d, e, j, i) \
    a = subSUBROUND1(a, ##funcname(b,c,d), e, k1[j], i); \
    c = ROTATE_L32(c, 10);

#define SUBROUND2(funcname, a, b, c, d, e, j, i) \
    a = subSUBROUND2(a, ##funcname(b,c,d), e, k2[j], i); \
    c = ROTATE_L32(c, 10);


void MakeRIPEMD160Helper_c(const void *pBuffer, void *hash, DWORD len)
{
    DWORD *w = (DWORD*)pBuffer;
    DWORD *h = (DWORD*)hash;
    DWORD A, B, C, D, E, T;
    DWORD Ad, Bd, Cd, Dd, Ed;
    DWORD i=len/64;

    A=h[0];   B=h[1];   C=h[2];   D=h[3];   E=h[4];
    Ad=h[0];  Bd=h[1];  Cd=h[2];  Dd=h[3];  Ed=h[4];

    while ( i > 0 ) {
        SUBROUND1(F1, A, B, C, D, E, 0,  0)     SUBROUND2(F5, Ad, Bd, Cd, Dd, Ed, 0,  0)
        SUBROUND1(F1, E, A, B, C, D, 0,  1)     SUBROUND2(F5, Ed, Ad, Bd, Cd, Dd, 0,  1)
        SUBROUND1(F1, D, E, A, B, C, 0,  2)     SUBROUND2(F5, Dd, Ed, Ad, Bd, Cd, 0,  2)
        SUBROUND1(F1, C, D, E, A, B, 0,  3)     SUBROUND2(F5, Cd, Dd, Ed, Ad, Bd, 0,  3)
        SUBROUND1(F1, B, C, D, E, A, 0,  4)     SUBROUND2(F5, Bd, Cd, Dd, Ed, Ad, 0,  4)
        SUBROUND1(F1, A, B, C, D, E, 0,  5)     SUBROUND2(F5, Ad, Bd, Cd, Dd, Ed, 0,  5)
        SUBROUND1(F1, E, A, B, C, D, 0,  6)     SUBROUND2(F5, Ed, Ad, Bd, Cd, Dd, 0,  6)
        SUBROUND1(F1, D, E, A, B, C, 0,  7)     SUBROUND2(F5, Dd, Ed, Ad, Bd, Cd, 0,  7)
        SUBROUND1(F1, C, D, E, A, B, 0,  8)     SUBROUND2(F5, Cd, Dd, Ed, Ad, Bd, 0,  8)
        SUBROUND1(F1, B, C, D, E, A, 0,  9)     SUBROUND2(F5, Bd, Cd, Dd, Ed, Ad, 0,  9)
        SUBROUND1(F1, A, B, C, D, E, 0, 10)     SUBROUND2(F5, Ad, Bd, Cd, Dd, Ed, 0, 10)
        SUBROUND1(F1, E, A, B, C, D, 0, 11)     SUBROUND2(F5, Ed, Ad, Bd, Cd, Dd, 0, 11)
        SUBROUND1(F1, D, E, A, B, C, 0, 12)     SUBROUND2(F5, Dd, Ed, Ad, Bd, Cd, 0, 12)
        SUBROUND1(F1, C, D, E, A, B, 0, 13)     SUBROUND2(F5, Cd, Dd, Ed, Ad, Bd, 0, 13)
        SUBROUND1(F1, B, C, D, E, A, 0, 14)     SUBROUND2(F5, Bd, Cd, Dd, Ed, Ad, 0, 14)
        SUBROUND1(F1, A, B, C, D, E, 0, 15)     SUBROUND2(F5, Ad, Bd, Cd, Dd, Ed, 0, 15)

        SUBROUND1(F2, E, A, B, C, D, 1, 16)     SUBROUND2(F4, Ed, Ad, Bd, Cd, Dd, 1, 16)
        SUBROUND1(F2, D, E, A, B, C, 1, 17)     SUBROUND2(F4, Dd, Ed, Ad, Bd, Cd, 1, 17)
        SUBROUND1(F2, C, D, E, A, B, 1, 18)     SUBROUND2(F4, Cd, Dd, Ed, Ad, Bd, 1, 18)
        SUBROUND1(F2, B, C, D, E, A, 1, 19)     SUBROUND2(F4, Bd, Cd, Dd, Ed, Ad, 1, 19)
        SUBROUND1(F2, A, B, C, D, E, 1, 20)     SUBROUND2(F4, Ad, Bd, Cd, Dd, Ed, 1, 20)
        SUBROUND1(F2, E, A, B, C, D, 1, 21)     SUBROUND2(F4, Ed, Ad, Bd, Cd, Dd, 1, 21)
        SUBROUND1(F2, D, E, A, B, C, 1, 22)     SUBROUND2(F4, Dd, Ed, Ad, Bd, Cd, 1, 22)
        SUBROUND1(F2, C, D, E, A, B, 1, 23)     SUBROUND2(F4, Cd, Dd, Ed, Ad, Bd, 1, 23)
        SUBROUND1(F2, B, C, D, E, A, 1, 24)     SUBROUND2(F4, Bd, Cd, Dd, Ed, Ad, 1, 24)
        SUBROUND1(F2, A, B, C, D, E, 1, 25)     SUBROUND2(F4, Ad, Bd, Cd, Dd, Ed, 1, 25)
        SUBROUND1(F2, E, A, B, C, D, 1, 26)     SUBROUND2(F4, Ed, Ad, Bd, Cd, Dd, 1, 26)
        SUBROUND1(F2, D, E, A, B, C, 1, 27)     SUBROUND2(F4, Dd, Ed, Ad, Bd, Cd, 1, 27)
        SUBROUND1(F2, C, D, E, A, B, 1, 28)     SUBROUND2(F4, Cd, Dd, Ed, Ad, Bd, 1, 28)
        SUBROUND1(F2, B, C, D, E, A, 1, 29)     SUBROUND2(F4, Bd, Cd, Dd, Ed, Ad, 1, 29)
        SUBROUND1(F2, A, B, C, D, E, 1, 30)     SUBROUND2(F4, Ad, Bd, Cd, Dd, Ed, 1, 30)
        SUBROUND1(F2, E, A, B, C, D, 1, 31)     SUBROUND2(F4, Ed, Ad, Bd, Cd, Dd, 1, 31)

        SUBROUND1(F3, D, E, A, B, C, 2, 32)     SUBROUND2(F3, Dd, Ed, Ad, Bd, Cd, 2, 32)
        SUBROUND1(F3, C, D, E, A, B, 2, 33)     SUBROUND2(F3, Cd, Dd, Ed, Ad, Bd, 2, 33)
        SUBROUND1(F3, B, C, D, E, A, 2, 34)     SUBROUND2(F3, Bd, Cd, Dd, Ed, Ad, 2, 34)
        SUBROUND1(F3, A, B, C, D, E, 2, 35)     SUBROUND2(F3, Ad, Bd, Cd, Dd, Ed, 2, 35)
        SUBROUND1(F3, E, A, B, C, D, 2, 36)     SUBROUND2(F3, Ed, Ad, Bd, Cd, Dd, 2, 36)
        SUBROUND1(F3, D, E, A, B, C, 2, 37)     SUBROUND2(F3, Dd, Ed, Ad, Bd, Cd, 2, 37)
        SUBROUND1(F3, C, D, E, A, B, 2, 38)     SUBROUND2(F3, Cd, Dd, Ed, Ad, Bd, 2, 38)
        SUBROUND1(F3, B, C, D, E, A, 2, 39)     SUBROUND2(F3, Bd, Cd, Dd, Ed, Ad, 2, 39)
        SUBROUND1(F3, A, B, C, D, E, 2, 40)     SUBROUND2(F3, Ad, Bd, Cd, Dd, Ed, 2, 40)
        SUBROUND1(F3, E, A, B, C, D, 2, 41)     SUBROUND2(F3, Ed, Ad, Bd, Cd, Dd, 2, 41)
        SUBROUND1(F3, D, E, A, B, C, 2, 42)     SUBROUND2(F3, Dd, Ed, Ad, Bd, Cd, 2, 42)
        SUBROUND1(F3, C, D, E, A, B, 2, 43)     SUBROUND2(F3, Cd, Dd, Ed, Ad, Bd, 2, 43)
        SUBROUND1(F3, B, C, D, E, A, 2, 44)     SUBROUND2(F3, Bd, Cd, Dd, Ed, Ad, 2, 44)
        SUBROUND1(F3, A, B, C, D, E, 2, 45)     SUBROUND2(F3, Ad, Bd, Cd, Dd, Ed, 2, 45)
        SUBROUND1(F3, E, A, B, C, D, 2, 46)     SUBROUND2(F3, Ed, Ad, Bd, Cd, Dd, 2, 46)
        SUBROUND1(F3, D, E, A, B, C, 2, 47)     SUBROUND2(F3, Dd, Ed, Ad, Bd, Cd, 2, 47)

        SUBROUND1(F4, C, D, E, A, B, 3, 48)     SUBROUND2(F2, Cd, Dd, Ed, Ad, Bd, 3, 48)
        SUBROUND1(F4, B, C, D, E, A, 3, 49)     SUBROUND2(F2, Bd, Cd, Dd, Ed, Ad, 3, 49)
        SUBROUND1(F4, A, B, C, D, E, 3, 50)     SUBROUND2(F2, Ad, Bd, Cd, Dd, Ed, 3, 50)
        SUBROUND1(F4, E, A, B, C, D, 3, 51)     SUBROUND2(F2, Ed, Ad, Bd, Cd, Dd, 3, 51)
        SUBROUND1(F4, D, E, A, B, C, 3, 52)     SUBROUND2(F2, Dd, Ed, Ad, Bd, Cd, 3, 52)
        SUBROUND1(F4, C, D, E, A, B, 3, 53)     SUBROUND2(F2, Cd, Dd, Ed, Ad, Bd, 3, 53)
        SUBROUND1(F4, B, C, D, E, A, 3, 54)     SUBROUND2(F2, Bd, Cd, Dd, Ed, Ad, 3, 54)
        SUBROUND1(F4, A, B, C, D, E, 3, 55)     SUBROUND2(F2, Ad, Bd, Cd, Dd, Ed, 3, 55)
        SUBROUND1(F4, E, A, B, C, D, 3, 56)     SUBROUND2(F2, Ed, Ad, Bd, Cd, Dd, 3, 56)
        SUBROUND1(F4, D, E, A, B, C, 3, 57)     SUBROUND2(F2, Dd, Ed, Ad, Bd, Cd, 3, 57)
        SUBROUND1(F4, C, D, E, A, B, 3, 58)     SUBROUND2(F2, Cd, Dd, Ed, Ad, Bd, 3, 58)
        SUBROUND1(F4, B, C, D, E, A, 3, 59)     SUBROUND2(F2, Bd, Cd, Dd, Ed, Ad, 3, 59)
        SUBROUND1(F4, A, B, C, D, E, 3, 60)     SUBROUND2(F2, Ad, Bd, Cd, Dd, Ed, 3, 60)
        SUBROUND1(F4, E, A, B, C, D, 3, 61)     SUBROUND2(F2, Ed, Ad, Bd, Cd, Dd, 3, 61)
        SUBROUND1(F4, D, E, A, B, C, 3, 62)     SUBROUND2(F2, Dd, Ed, Ad, Bd, Cd, 3, 62)
        SUBROUND1(F4, C, D, E, A, B, 3, 63)     SUBROUND2(F2, Cd, Dd, Ed, Ad, Bd, 3, 63)

        SUBROUND1(F5, B, C, D, E, A, 4, 64)     SUBROUND2(F1, Bd, Cd, Dd, Ed, Ad, 4, 64)
        SUBROUND1(F5, A, B, C, D, E, 4, 65)     SUBROUND2(F1, Ad, Bd, Cd, Dd, Ed, 4, 65)
        SUBROUND1(F5, E, A, B, C, D, 4, 66)     SUBROUND2(F1, Ed, Ad, Bd, Cd, Dd, 4, 66)
        SUBROUND1(F5, D, E, A, B, C, 4, 67)     SUBROUND2(F1, Dd, Ed, Ad, Bd, Cd, 4, 67)
        SUBROUND1(F5, C, D, E, A, B, 4, 68)     SUBROUND2(F1, Cd, Dd, Ed, Ad, Bd, 4, 68)
        SUBROUND1(F5, B, C, D, E, A, 4, 69)     SUBROUND2(F1, Bd, Cd, Dd, Ed, Ad, 4, 69)
        SUBROUND1(F5, A, B, C, D, E, 4, 70)     SUBROUND2(F1, Ad, Bd, Cd, Dd, Ed, 4, 70)
        SUBROUND1(F5, E, A, B, C, D, 4, 71)     SUBROUND2(F1, Ed, Ad, Bd, Cd, Dd, 4, 71)
        SUBROUND1(F5, D, E, A, B, C, 4, 72)     SUBROUND2(F1, Dd, Ed, Ad, Bd, Cd, 4, 72)
        SUBROUND1(F5, C, D, E, A, B, 4, 73)     SUBROUND2(F1, Cd, Dd, Ed, Ad, Bd, 4, 73)
        SUBROUND1(F5, B, C, D, E, A, 4, 74)     SUBROUND2(F1, Bd, Cd, Dd, Ed, Ad, 4, 74)
        SUBROUND1(F5, A, B, C, D, E, 4, 75)     SUBROUND2(F1, Ad, Bd, Cd, Dd, Ed, 4, 75)
        SUBROUND1(F5, E, A, B, C, D, 4, 76)     SUBROUND2(F1, Ed, Ad, Bd, Cd, Dd, 4, 76)
        SUBROUND1(F5, D, E, A, B, C, 4, 77)     SUBROUND2(F1, Dd, Ed, Ad, Bd, Cd, 4, 77)
        SUBROUND1(F5, C, D, E, A, B, 4, 78)     SUBROUND2(F1, Cd, Dd, Ed, Ad, Bd, 4, 78)
        SUBROUND1(F5, B, C, D, E, A, 4, 79)     SUBROUND2(F1, Bd, Cd, Dd, Ed, Ad, 4, 79)

        T    = h[1] + C + Dd;
        h[1] = h[2] + D + Ed;
        h[2] = h[3] + E + Ad;
        h[3] = h[4] + A + Bd;
        h[4] = h[0] + B + Cd;
        h[0] = T;

        A=h[0];   B=h[1];   C=h[2];   D=h[3];   E=h[4];
        Ad=h[0];  Bd=h[1];  Cd=h[2];  Dd=h[3];  Ed=h[4];

        w+=16;
        i--;
    }
}



////////////////////////////////////////////////////////////////////////////////////////////////////
// test

BOOL CMakeRIPEMD160::Test()
{
    static const char *q1 = "abc";
    static const char *q2 = "abcdefghijklmnopqrstuvwxyz";
    static const char *q3 = "abcdbcdecdefdefgefghfghighijhijkijkljklmklmnlmnomnopnopq";
    static const char *q4 = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";
    static const char *q5 = "12345678901234567890123456789012345678901234567890123456789012345678901234567890";

    static const char *a0 = "9c1185a5c5e9fc54612808977ee8f548b2258d31";
    static const char *a1 = "8eb208f7e05d987a9b044a8e98c6b087f15a0bfc";
    static const char *a2 = "f71c27109c692c1b56bbdceb5b9d2865b3708dbc";
    static const char *a3 = "12a053384a9c0c88e405a06c27dcf49ada62eb2b";
    static const char *a4 = "b0e20b6e3116640286ed3a87a5713079b21f5189";
    static const char *a5 = "9b752e45573d4b39f4dbd3323cab82bf63326bfb";
    static const char *a6 = "52783243c1697bdbe16d37f97f68f08325dc1528";


    Initialize();
    if ( CmpHashValue(a0) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    ComputeHash(q1, strlen(q1));
    if ( CmpHashValue(a1) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    ComputeHash(q2, strlen(q2));
    if ( CmpHashValue(a2) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    ComputeHash(q3, strlen(q3));
    if ( CmpHashValue(a3) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    ComputeHash(q4, strlen(q4));
    if ( CmpHashValue(a4) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    ComputeHash(q5, strlen(q5));
    if ( CmpHashValue(a5) ) {
        ASSERT(0);
        return FALSE;
    }

    Initialize();
    BYTE *pQ6=new BYTE[1000000];
    memset(pQ6, 'a', 1000000);
    ComputeHash(pQ6, 1000000);
    delete [] pQ6;
    if ( CmpHashValue(a6) ) {
        ASSERT(0);
        return FALSE;
    }

    return TRUE;
}

